;Programm	   	: rxtx433.asm
;Datum   	   	: 12.12.2016
;Name		    : Dipl.-Ing. W. Sontopski
;Controller	 	: ATmega48
;Clock		   	: Quarz 10.24MHz
;Board       	: L2510151 (433MHz RX-TX-Sensor)
;Kunde       	: soni
;Programmfile	: LLxxxx12.elf
;--------------------------------------
;fosc 10.24 Mhz
;baudrate	UBRRL	error(%)
;4800		132
;9600		??		0
;19200		??		0
;38400		??		0
;56000		??		0 
;57600		10		1
;76800		??		0
;115200		??		0
;------------------------------------------------
.include	"m48def.inc"

.equ	Klingel = 0
.equ	TR402 	= 0
.equ	Nova  	= 1

.equ	bd4800		= 132
.equ	bd57600		= 10


;--------------------------------------------------------
;Trfunkklingel
.if	(Klingel)
.equ	bit_cnt		=  13		;anzahl der bits (Klingel))
.equ	t_muell		=  50		;50 x 10usec = 500usec (Klingel)
.equ	t1_bit		=  100		;100 x 10usec = 1000usec (Klingel)
.equ	tabcnt		=  1		;1
.endif 
;----------------------------------------------------------
.if	( TR402 )
;----------------------------------------------------------
;TR402 Fernbedienung
.equ	bit_cnt		=  21		;anzahl der bits (TR402)
.equ	t_muell		=  40		;40 x 10usec = 400usec (TR402)
.equ	t1_bit		=  100		;100 x 10usec = 1000usec (TR402)
.equ	tabcnt		=  8		;8
.endif 
;-----------------------------------------------------------
.if ( Nova )
;-----------------------------------------------------------
;NovaStar Fernbedienung
.equ	bit_cnt		=  25		;anzahl der bits
.equ	t_muell		=  10		;10 x 10usec = 100usec
.equ	t1_bit		=  80		;80 x 10usec = 800usec
.equ	tabcnt		=  8		;8
.endif

;-----------------------------------------------------------



.equ	gruen		= 4
.equ	rot			= 2




	.dseg

chn:		.byte	1
ds_end:		.byte	1


	.cseg

	.org 0

rxtx_1:
	ldi		r16,low(RAMEND)
	out		SPL,r16				;init. stackpointer
	ldi		r16,high(RAMEND)
	out		SPH,r16				;init. stackpointer
	rcall	wdt_off				;watchdog aus
	ldi		r16,0b00000000
	out		PORTB,r16 
	ldi		r16,0b00010111
	out		DDRB,r16			;set portb i/o-config.(0=in)
	ldi		r16,0b00000000		;integrator reset
	out		PORTC,r16 
	ldi		r16,0b00011111
	out		DDRC,r16			;set portc i/o-config.(0=in)
	ldi		r16,0b00100000
	out		PORTD,r16
	ldi		r16,0b00101010
	out		DDRD,r16			;set portd i/o-config.(0=in)
	clr		r16			
	sts		UBRR0H,r16
	ldi		r16,bd57600			;
	sts		UBRR0L,r16			;bd-rate setzen
	ldi		r16,0b00011000		;usart rx,tx ein
	sts		UCSR0B,r16 
	ldi		r16,0b00000110		;8bit/noparity/1stop
	sts		UCSR0C,r16
;	rjmp	ser_tst				;**********test only
tt2:
;	ldi		r16,0xfe
;	rcall	lbyte
;	rjmp	tt2
	rjmp	rx433				;**********test only

;-----------------------------------------------
;empfngt den code der 433Mhz-Fernbedienung
;fr funksteckdosen.
;Wird ein gltiger code gefunden, wird in r16
;eine entsprechende kanalnr. zurckgegeben.
;als empfangsmodul wird ein XD-RF-5V (China) verwendet.
;ints mssen aus sein
;0=lange zeit high , 1 = kurze zeit high

rx433:
	cli					;ints aus
rx41:
	clr		r4
	clr		r5
	clr		r6
	sbic	pind,2
	rjmp	rx41		;warten auf 0
	clr		r16			;100usec-cnt = 0
rx42:
	cpi		r16,0xff	;test max-cnt
	breq	rx43
	inc		r16
rx43:
	rcall	del100us
	sbis	pind,2
	rjmp	rx42		;warten auf 0 -> 1
	cpi		r16,50		;test startbedigung >5msec
	brcs	rx41		;
	ldi		r17,bit_cnt	;r17= bit-cnt
rx44:
	clr		r16			;10usec-cnt = 0
rx45:
	rcall	del10us
	inc		r16
	sbic	pind,2
	rjmp	rx45		;warten bis 1 -> 0
	cpi		r16,t_muell
	brcs	rx433		;zu kurz -> muell
	clc
	cpi		r16,t1_bit	;test ob 0 oder 1
	rol		r4			;cy =1 wenn lange zeit high
	rol		r5
	rol		r6
rx46:
	sbis	pind,2
	rjmp	rx46		;warten auf 0 -> 1
	dec		r17			;bit_cnt -1
	brne	rx44		;nchstes bit
rx48:
	rcall	lr6r5r4
;	rjmp	rx433
	clr		r18			;setzt kanalnr. =0
	ldi		zh,high(kanal0<<1)
	ldi		zl,low(kanal0<<1)
rx49:
	rcall	chk_kanal
	brcc	rx410
	inc		r18
	cpi		r18,tabcnt	;test tabellenende
	brne	rx49		;nchster eintrag
	rjmp	rx433		;kein eintrag gefunden
rx410:
	mov		r16,r18		;kanal-nr. in r18
;	rcall	lbyte		;ab hier democode
	cpi		r18,0
	brne	rx433
	sbi		portb,0		;relais ein
	sbi		portd,3		;pieper ein
;	rcall	crlf
	rcall	del1s
	cbi		portd,3		;pieper aus
	cbi		portb,0		;relais aus
	rjmp	rx433

;
			
;test kanal(n)
;vergleicht den inhalt von r6:r5:r4 (rx_433)
;mit den sollwerten fr kanal(n)
;zu beginn: z = adresse kanal(n)-werte
;am ende: cy = 0 -> wert gefunden
;         cy = 1 -> wert nicht gefunden
	
chk_kanal:
	lpm		r16,z+
	cp		r16,r6
	brne	ck1
	lpm		r16,z+
	cp		r16,r5
	brne	ck2
	lpm		r16,z+
	cp		r16,r4
	brne	ck3
	ret
ck1:
	adiw	z,1
ck2:
	adiw	z,1
ck3:
	adiw	z,1
	sec					;fehler cy = 1
	ret
	

.if (Klingel)
;Trfunkklingel
kanal0:	.db		0x0,0x1c,0xcf	;Funkklingel
.endif

.if ( TR402 )
;kanal(n)werte TR402 fernbedienung, 21 bit
kanal0:	.db		0x1f,0x50,0x00	;taste 1/AUS
kanal1:	.db		0x1f,0x50,0x11	;taste 1/EIN
Kanal2:	.db		0x1f,0x50,0x82	;taste 2/AUS
Kanal3:	.db		0x1f,0x50,0x93	;taste 2/EIN
kanal4:	.db		0x1f,0x50,0x41	;taste 3/AUS
kanal5:	.db		0x1f,0x50,0x50	;taste 3/EIN
Kanal6:	.db		0x1f,0x50,0xc3	;taste 4/AUS
Kanal7:	.db		0x1f,0x50,0xd2	;taste 4/EIN
.endif

.if ( Nova )
;kanal(n)werte NovaStar fernbedienung, 25 bit
kanal0:	.db		0x76,0x75,0x57	;taste A/AUS
kanal1:	.db		0x76,0x75,0x5d	;taste A/EIN
Kanal2:	.db		0x76,0x5d,0x57	;taste B/AUS
Kanal3:	.db		0x76,0x5d,0x5d	;taste B/EIN
kanal4:	.db		0x76,0x57,0x57	;taste C/AUS
kanal5:	.db		0x76,0x57,0x5d	;taste C/EIN
Kanal6:	.db		0x76,0x55,0xd7	;taste D/AUS
Kanal7:	.db		0x76,0x55,0xdd	;taste D/EIN

.endif


;-----------------------------------------------
;testet den 433 Mhz sender FS1000A
;Senderspannung: 12V (geht sehr weit)
tx_433:
	sbi		portc,3
	rcall	del2ms
	cbi		portc,3
	rcall	del5ms
	ldi		r16,0x1c	;klingelcode msb
	rcall	tx_byte	
	ldi		r16,0xcf	;klingelcode lsb
	rcall	tx_byte
	cbi		portc,3
	rcall	del10ms	
	rjmp	tx_433

tx_byte:
	ldi		r17,8		;8 bit
	clc
txb1:
	rol		r16
	brcs	txb2
	rcall	tx_zero
	rjmp	txb3
txb2:
	rcall	tx_one
txb3:
	dec		r17
	brne	txb1
	ret


	
tx_one:
	cbi		portc,3
	rcall	del2ms
	sbi		portc,3
	rcall	del1ms
	cbi		portc,3
	ret
tx_zero:
	cbi		portc,3
	rcall	del1ms
	sbi		portc,3
	rcall	del2ms
	cbi		portc,3
	ret


;------------------------------------------------
;gibt r6,r5,r4 in hex auf der konsolse aus
lr6r5r4:
	mov		r16,r6
	rcall	lbyte
	mov		r16,r5
	rcall	lbyte
	mov		r16,r4
	rcall	lbyte
	rcall	blk
	rcall	crlf
	ret

	


;------------------------------------------------
;lscht (00) alle variablen von chn bis ds_end
clr_ram:
	push	r16
	push	r17
	clr		r16			
	ldi		r17,((ds_end - chn)+1)
	ldi		zl,low(chn)		;startadr. chn
	ldi		zh,high(chn)
cra1:
	st		z+,r16
	dec		r17
	brne	cra1
	pop		r17
	pop		r16
	ret


;--------------------------------------------------
;schaltet den portpin bei jedem aufruf um
;praktisch zur zeitmessung zwischen zwei aufrufe.
;zu beginn: portb,1

blink:
	sbic	portb,1
	rjmp	blink1
	sbi		portb,1
	ret
blink1:
	cbi		portb,1
	ret



;------------------------------------------------
;deaktiviert den Watchdog
wdt_off:
	wdr
	in		r16,MCUSR
	andi	r16,(0xff & (0<<WDRF))
	out		MCUSR,r16
	lds		r16,WDTCSR
	ori		r16,(1<<WDCE) | (1<<WDE)
	sts		WDTCSR,r16
	ldi		r16,(0<<WDE)
	sts		WDTCSR,r16
	ret



;-----------------------------------------------
;gibt r16 und 17 binr aus.
;anschliessend 1 x cr
tx_bin_r16_r17:
	push	r16
	rcall	co				;low-byte ausgeben
	mov		r16,r17
	rcall	co				;high-byte ausgeben
	ldi		r16,0x0d
	rcall	co
	pop		r16
	ret

	
;------------------------------------------------
;lr17r16_hex_blk
;gibt r17,r16 in hex ber die
;serielle schnittstelle aus.
;anschliessend 1 x leerzeichen

lr17r16_hex_blk:
	rcall	lr17r16_hex
	rjmp	blk
;------------------------------------------------
;lr17r16_hex_cr
;gibt r17,r16 in hex ber die
;serielle schnittstelle aus.
;anschliessend 1 x cr (0x0d)

lr17r16_hex_cr:
	rcall	lr17r16_hex
	rjmp	cr



;------------------------------------------------
;lr17r16_hex_crlf
;gibt r17,r16 in hex ber die
;serielle schnittstelle und anschliessend
; 1 x crlf aus

lr17r16_hex_crlf:
	rcall	lr17r16_hex
	rjmp	crlf		

;------------------------------------------------
;lr17r16_hex
;gibt r17,r16 in hex ber die
;serielle schnittstelle aus

lr17r16_hex:
	push	r16
	mov		r16,r17		;high-byte zuerst
	rcall	lbyte
	pop		r16			;dann low-byte
	rjmp	lbyte
;------------------------------------------------
;lr21r20_hex
;gibt r21:r20 in hex ber die
;serielle schnittstelle aus

lr21r20_hex:
	push	r16
	mov		r16,r21		;high-byte zuerst
	rcall	lbyte
	mov		r16,r20		;dann low-byte
	rcall	lbyte
	pop		r16
	ret	
;------------------------------------------------
;lr21r20_hex_crlf
;gibt r21:r20 in hex ber die
;serielle schnittstelle und anschliessend
; 1 x crlf aus

lr21r20_hex_crlf:
	rcall	lr21r20_hex
	rjmp	crlf		
		

;------------------------------------------------
;testet das senden der seriellen schnittstelle RTX0
;test mit $(00 Bd ok.
ser_tst:
	ldi		r16,0x55
st1:
	rcall	co
;	inc		r16
	rjmp	st1
;------------------------------------------------
;------------------------------------------------
;zeigt statusreg. als bitfolge ueber usart an.
sregu:
	push	r16
	in		r16,SREG
	push	r16
	rcall	crlf
	rcall	lbit
	pop		r16
	out		SREG,r16
	pop		r16
	ret
;----------------------------------------------------------
;zeigt statusreg. als bitfolge und
;reg0.....reg32 in hex an
reg_d:
	push	r31			;sichert r31 auf stack
	push	r30			;sichert r30 auf stack
	push	r17			;sichert r17 auf stack
	push	r16			;sichert r16 auf stack
	push	r31
	push	r30
	push	r17
	push	r16
	rcall	crlf
	in		r16,SREG
	rcall	lbit		;und zeigt bits an
	rcall	crlf
	clr		r30			;start von r0 (Z adresse 0)
	clr		r31			;start von r0 (Z adresse 0)		
	ldi		r17,16		;r0....r15
rdp1:
	rcall	lreg		;zeigt r0...r15 an
	rcall	crlf
	pop		r16			;holt r16 von stack
	rcall	lbyte		;und zeigt r16 an
	rcall	blk
	pop		r16			;holt r17 von stack
	rcall	lbyte		;und zeigt r17 an
	rcall	blk
	subi	r30,-2
	ldi		r17,12
rdp2:
	rcall	lreg		;zeigt r18...r29 an
	pop		r16			;holt r30 von stack
	rcall	lbyte		;und zeigt r30 an
	rcall	blk
	pop		r16			;holt r31 von stack
	rcall	lbyte		;und zeigt r31 an
	rcall	blk
	pop		r16
	pop		r17
	pop		r30
	pop		r31
	ret


;----------------------------------------------------------
;holt byte aus adresse (Z), erhoeht adresse Z
;und zeigt byte in hex ueber uart-port an.
;wiederholt den vorgang bis r17 = 0.
;zu beginn: r17 = schleifenzaehler
;			Z   = Startadresse
		
lreg:
	ld		r16,Z+
	rcall	lbyte
	rcall	blk
	dec		r17
	brne	lreg
	ret


;----------------------------------------------------------
;lbyte
;gibt byte in r16 als hex-wert ueber usart aus. 

lbyte:
	push	r16			;rette byte
	push	r16			;rette byte
	swap	r16			;vertausche obere und untere 4 bit
	rcall	hxd			;wandle unteren 4 bits -> hex
	pop		r16			;stelle das byte wieder her
	rcall	hxd			;wandle obere 4 bits -> hex
	pop		r16			;stelle das byte wieder her
	ret
;----------------------------------------------------------
hxd:
	rcall	conv		;convertiert nibble -> hex
	rjmp	co			;und gibt aus

;----------------------------------------------------------
; conv
;convertiert 4 bit bin-wert -> ascii char.
;input  reg r16 = 0....fh
;output reg r16 = 30h....39h,  41h....46h
	
conv:				;                             		
	andi	r16,0x0f	; bit 7...4 = 0
	subi	r16,-'0'	;addiere ASCII 0               		
	cpi		r16,'9'+1	;ziffern A...F?                		
	brcs	conv1		; --> Yes (A to F set)        		
	subi	r16,-7		;addiere 7 fuer A...F
conv1:
	ret
					;                             		
;----------------------------------------------------------
;byte in hex -> console, 1 x leerzeichen
;zu beginn: r16 = byte

lbyte_blk:
	rcall	lbyte
;----------------------------------------------------------	
; "blk"
; ausgabe 1 x leerzeichen ueber usart

blk:
	push	r16
	ldi		r16,0x20
	rcall	co
	pop		r16
	ret
;----------------------------------------------------------	
; "cr"
; ausgabe 1 x cr (0x0d) ueber usart

cr:
	push	r16
	ldi		r16,0x0d
	rcall	co
	pop		r16
	ret

;----------------------------------------------------------
; "crlf"
; ausgabe 1 x crlf ueber usart

crlf:
	push	r16
	ldi		r16,0x0a
	rcall	co
	ldi		r16,0x0d
	rcall	co
	rcall	del10ms		;fuer hyperterminal
	pop		r16
	ret

;----------------------------------------------------------
;lbit
;gibt byte in r16 als folge von 0 und 1 ueber usart an.
;zu beginn: r16 = byte

lbit:
	push	r16
	push	r17
	push	r18
	mov		r18,r16
	ldi		r17,8
lbp1:
	ldi		r16,'0'
	rol		r18
	brcc	lbp2
	inc		r16
lbp2:
	rcall	co
	rcall	blk
	dec		r17
	brne	lbp1
	pop		r18
	pop		r17
	pop		r16
	ret


;------------------------------------------------
;empfaengt byte ueber rxd (pin9)
ci:
	lds		r16,UCSR0A
	sbrs	r16,RXC0
	rjmp	ci
	lds		r16,UDR0
	ret
;------------------------------------------------
;sendet byte in r16 ueber txd (pin10)
;zu beginn: r16 = sendebyte
co:
	push	r16
co1:
	lds		r16,UCSR0A
	sbrs	r16,UDRE0			;test transmitter leer
	rjmp	co1
	pop		r16
	sts		UDR0,r16			;sendet byte in r16
	ret
;************************************************

;------------------------------------------------
;stringz
;2.) ausgabe einer mit 0 abgeschlossenen 
;zeichenkette (asciiz) zur Console
;start : z = startadresse
;ende  : z = startadresse

stringz:
	push	r16
	push	zl
	push	zh
	rcall	crlf	
strz1:
	lpm		r16,z+			;holt zeichen
	and		r16,r16			;test ob ende (=0)
	breq	strz2
	rcall	co				;zeichen -> console
	rjmp	strz1
strz2:
	pop		zh
	pop		zl
	pop		r16
	ret

;------------------------------------------------



;------------------------------------------------
;wechselt die polaritt von port b0

tog_pb0:
	sbi		portb,0
	rcall	del100ms
	cbi		portb,0
	rcall	del100ms
	rjmp	tog_pb0


;------------------------------------------------
;wechselt die polaritt von port d3

tog_pd3:
	sbi		portd,3
	rcall	del1ms
	cbi		portd,3
	rcall	del1ms
	rjmp	tog_pd3

;------------------------------------------------
;wechselt die polaritt von port d5

tog_pd5:
	sbi		portd,5
	rcall	del100us
	cbi		portd,5
	rcall	del100us
	rjmp	tog_pd5
;-------------------------------------------------
;schaltet den pieper stndig ein/aus
piep:
	sbi		portd,3
	rcall	del100ms
	cbi		portd,3
	rcall	del100ms
	rjmp	piep

;-------------------------------------------------
;delays clk = 10.24 MHz

del5us:
	push	r16
	ldi		r16,10
	rjmp	del10u_1

del9us:
	push	r16
	ldi		r16,27
	rjmp	del10u_1

del10us:
	push	r16
	ldi		r16,29
del10u_1:
	dec		r16
	brbc	1,del10u_1
	pop		r16
	ret

del13us:
	push	r16
	ldi		r16,40
	rjmp	del10u_1

del16us:
	push	r16
	ldi		r16,50
	rjmp	del10u_1

del26us:
	push	r16
	ldi		r16,83
	rjmp	del10u_1

del52us:
	push	r16
	ldi		r16,173
	rjmp	del10u_1

delr16:
	push	r16
	rjmp	del100u_1

del100us:
	push	r16
	ldi		r16,10
del100u_1:
	push	r16
	rcall	del9us
	pop		r16
	dec		r16
	brbc	1,del100u_1
	pop		r16
	ret

del470us:
	push	r16
	ldi		r16,47
	rjmp	del100u_1

del1ms:
	push	r16
	ldi		r16,100
	rjmp	del100u_1

del2ms:
	push	r16
	ldi		r16,200
	rjmp	del100u_1

del5ms:
	push	r16
	ldi		r16,5
	rjmp	del10m_1

del10ms:
	push	r16
	ldi		r16,10
del10m_1:
	push	r16
	rcall	del1ms
	pop		r16
	dec		r16
	brbc	1,del10m_1
	pop		r16
	ret
del20ms:
	push	r16
	ldi		r16,20
	rjmp	del10m_1
del40ms:
	push	r16
	rcall	del470us
	ldi		r16,40
	rjmp	del10m_1

del100ms:
	push	r16
	ldi		r16,101
	rjmp	del10m_1
del200ms:
	push	r16
	ldi		r16,199
	rjmp	del10m_1
del500ms:
	push	r16
	ldi		r16,5
	rjmp	del1s_1
del1s:
	push	r16
	ldi		r16,10
del1s_1:
	push	r16
	rcall	del100ms
	pop		r16
	dec		r16
	brbc	1,del1s_1
	pop		r16
	ret
del2s:
	push	r16
	ldi		r16,20
	rjmp	del1s_1
del5s:
	push	r16
	ldi		r16,50
	rjmp	del1s_1
	
;------------------------------------------------


